#ifndef BLD_CONDOP_H
#define BLD_CONDOP_H

/******************************************************************************

Copyright (c) 1997, Andrew J. Weber, Jason P. Weber

Copyright information should have been included with this distribution
and may be found at ../meta/COPYRIGHT or obtained via email from weber@acm.org

******************************************************************************/

#include <gpl/gpl.h>
#include <bld/op.h>

/***********************************************************************
class BLD_AlternativeOperation

Perform one of two alternatives.
***********************************************************************/
class BLD_AlternativeOperation : public BLD_Operation
{
	public:
		BLD_AlternativeOperation(BLD_Operation *c, BLD_Operation *a)
			: condition(c), affirmative(a) {}
		BLD_AlternativeOperation(BLD_Operation *c, BLD_Operation *a, BLD_Operation *n)
			: condition(c), affirmative(a), negative(n) {}
		virtual ~BLD_AlternativeOperation(void) {}

		virtual BLD_Value Perform(void) const;
		virtual GPL_String ToString(void) const;

	protected:
		GPL_Pointer<BLD_Operation> condition;
		GPL_Pointer<BLD_Operation> affirmative;
		GPL_Pointer<BLD_Operation> negative;
};

/***********************************************************************
class BLD_BreakOperation

Break out of targets.
***********************************************************************/
class BLD_BreakOperation : public BLD_Operation
{
	public:
		BLD_BreakOperation(const GPL_Boolean t = TRUE) : topOnly(t) {}
		virtual ~BLD_BreakOperation(void) {}

		virtual BLD_Value Perform(void) const;
		virtual GPL_String ToString(void) const;

	protected:
		GPL_Boolean topOnly;
};

#endif /* BLD_CONDOP_H */
