
/******************************************************************************

Copyright (c) 1997, Andrew J. Weber, Jason P. Weber

Copyright information should have been included with this distribution
and may be found at ../meta/COPYRIGHT or obtained via email from weber@acm.org

******************************************************************************/

#include <bld/relop.h>

/******************************************************************************
class BLD_EqualOperation
******************************************************************************/
BLD_Value BLD_EqualOperation::Perform(void) const
{
	const BLD_Value l = left->Perform();
	const BLD_Value r = right->Perform();
	return (l == r) ? BLD_Value::truth : BLD_Value::falsehood;
}

GPL_String BLD_EqualOperation::ToString(void) const
{
	GPL_String image;
	image.Printf("(%s == %s)", left->ToString().GetData(), right->ToString().GetData());
	return image;
}

/******************************************************************************
class BLD_NotEqualOperation
******************************************************************************/
BLD_Value BLD_NotEqualOperation::Perform(void) const
{
	const BLD_Value l = left->Perform();
	const BLD_Value r = right->Perform();
	return (l != r) ? BLD_Value::truth : BLD_Value::falsehood;
}

GPL_String BLD_NotEqualOperation::ToString(void) const
{
	GPL_String image;
	image.Printf("(%s != %s)", left->ToString().GetData(), right->ToString().GetData());
	return image;
}

/******************************************************************************
class BLD_LessOperation
******************************************************************************/
BLD_Value BLD_LessOperation::Perform(void) const
{
	const BLD_Value l = left->Perform();
	const BLD_Value r = right->Perform();
	return (l < r) ? BLD_Value::truth : BLD_Value::falsehood;
}

GPL_String BLD_LessOperation::ToString(void) const
{
	GPL_String image;
	image.Printf("(%s < %s)", left->ToString().GetData(), right->ToString().GetData());
	return image;
}

/******************************************************************************
class BLD_LessEqualOperation
******************************************************************************/
BLD_Value BLD_LessEqualOperation::Perform(void) const
{
	const BLD_Value l = left->Perform();
	const BLD_Value r = right->Perform();
	return (l <= r) ? BLD_Value::truth : BLD_Value::falsehood;
}

GPL_String BLD_LessEqualOperation::ToString(void) const
{
	GPL_String image;
	image.Printf("(%s <= %s)", left->ToString().GetData(), right->ToString().GetData());
	return image;
}

/******************************************************************************
class BLD_GreaterOperation
******************************************************************************/
BLD_Value BLD_GreaterOperation::Perform(void) const
{
	const BLD_Value l = left->Perform();
	const BLD_Value r = right->Perform();
	return (l > r) ? BLD_Value::truth : BLD_Value::falsehood;
}

GPL_String BLD_GreaterOperation::ToString(void) const
{
	GPL_String image;
	image.Printf("(%s > %s)", left->ToString().GetData(), right->ToString().GetData());
	return image;
}

/******************************************************************************
class BLD_GreaterEqualOperation
******************************************************************************/
BLD_Value BLD_GreaterEqualOperation::Perform(void) const
{
	const BLD_Value l = left->Perform();
	const BLD_Value r = right->Perform();
	return (l >= r) ? BLD_Value::truth : BLD_Value::falsehood;
}

GPL_String BLD_GreaterEqualOperation::ToString(void) const
{
	GPL_String image;
	image.Printf("(%s >= %s)", left->ToString().GetData(), right->ToString().GetData());
	return image;
}

