#!/usr/local/bin/perl -w

require 5.000;
use strict;
use English;
use FileHandle;
require Carp;
require Getopt::Long;
require Cwd;

my($debug) = 0;
my($rc) = 0;

sub checkFile
{
	my($fileName) = shift;
	if (-f $fileName)
	{
		my ($manFileName) = $fileName;
		$manFileName =~ s/\..*?$/.man/;
		STDOUT->print("\$manFileName == \"$manFileName\"\n") if $debug;
		unless (-f $manFileName && -s _)
		{
			STDERR->print("$manFileName does not exist!\n");
			return 1;
		}
	}
	return 0;
}

# Parse the command-line options.
$Getopt::Long::autoabbrev = 1 unless $Getopt::Long::autoabbrev;
&Getopt::Long::GetOptions (
	'debug!' => \$debug,
);

foreach $::ARG (@::ARGV)
{
	if ($::ARG !~ m/^\//)
	{
		$::ARG = &Cwd::cwd() . "/" . $::ARG;
	}
	$rc += &checkFile($::ARG);
}

exit ($rc);

__END__
